program konaenc;

{$APPTYPE CONSOLE}

uses
 SysUtils;

var
 F1, F2: File;
//Compressing vars
 Terminator: Integer;
 LoadRunner: Byte;
 Mem_Runner: PByte;
 UniCounter: Integer;
 MemBufSize: Integer;
 DContainer: PByteArray;
 NoCmpBlock: array[0..127] of Byte;
 EncodeMode: Integer;
procedure WriteBlock;
begin
 case EncodeMode of
  1:
  begin
   BlockWrite(F2, UniCounter, 1);
   BlockWrite(F2, LoadRunner, 1);
  end;
  2:
  begin
   UniCounter := UniCounter or $80;
   BlockWrite(F2, UniCounter, 1);
   BlockWrite(F2, NoCmpBlock, UniCounter and $7F);
  end;
 end;
end;
begin
 AssignFile(F1, ParamStr(1));
 AssignFile(F2, ParamStr(2));
 try
  Reset(F1, 1);
  try
   MemBufSize := FileSize(F1);
   GetMem(DContainer, MemBufSize);
   try
    BlockRead(F1, DContainer^, MemBufSize);
    (* Prepare output file *)
    Rewrite(F2, 1);
    try
     (* Main loop *)
     UniCounter := 0;
     EncodeMode := 0;
     Mem_Runner := Pointer(DContainer);
     while MemBufSize > 0 do
     begin
      case EncodeMode of
       0:
       begin
        LoadRunner := Mem_Runner^;
        Inc(Mem_Runner);
        Dec(MemBufSize);
        Inc(UniCounter);
        EncodeMode := 1;
       end;
       1:
       if Mem_Runner^ = LoadRunner then
       begin
        if UniCounter < 126 then
        begin
         Inc(UniCounter);
         Inc(Mem_Runner);
         Dec(MemBufSize);
        end else
        begin
         WriteBlock;
         UniCounter := 0;
         EncodeMode := 0;
        end;
       end else if Unicounter > 2 then
       begin
        WriteBlock;
        UniCounter := 0;
        EncodeMode := 0;
       end else
       begin
        NoCmpBlock[0] := LoadRunner;
        NoCmpBlock[1] := LoadRunner;
        EncodeMode := 2;
       end;
       2:
       if (UniCounter < 126) and (Mem_Runner^ <> LoadRunner) then
       begin
        NoCmpBlock[UniCounter - 1] := LoadRunner;
        LoadRunner := Mem_Runner^;
        Inc(UniCounter);
        Inc(Mem_Runner);
        Dec(MemBufSize);
       end else if UniCounter < 126 then
       begin
        if (MemBufSize > 1) and
           (Byte(Pointer(Integer(Mem_Runner) + 1)^) = LoadRunner) then
        begin
         Dec(UniCounter);
         WriteBlock;
         UniCounter := 1;
         EncodeMode := 1;
        end else
        begin
         NoCmpBlock[UniCounter - 1] := LoadRunner;
         LoadRunner := Mem_Runner^;
         Inc(UniCounter);
         Inc(Mem_Runner);
         Dec(MemBufSize);
        end;
       end else
       begin
        WriteBlock;
        UniCounter := 0;
        EncodeMode := 0;
       end;
      end;
     end;
     if UniCounter > 0 then WriteBlock;
     Terminator := 255;
     BlockWrite(F2, Terminator, 1);
     Writeln(Format('Decompressed size: %d', [FilePos(F1)]));
     Writeln(Format('Compressed size: %d', [FileSize(F2)]));
    finally
     CloseFile(F2);
    end;
   finally
    FreeMem(DContainer);
   end;            
  finally
   CloseFile(F1);
  end;
 except
  on E: Exception do Writeln(E.Message);
 end;
end.
